<?php
/**
 * @version		$Id: fulldescription.php,v 1.21 2009/08/08 11:51:49 juanca Exp $
 * @package		vpl. launch fulldescription_form
 * @copyright	Copyright (C) 2009 Juan Carlos Rodríguez-del-Pino. All rights reserved.
 * @license		GNU/GPL, see LICENSE.txt or http://www.gnu.org/licenses/gpl-2.0.html
 * @author		Juan Carlos Rodriguez-del-Pino
 **/

require_once('../../../config.php');
require_once('../lib.php');
require_once('fulldescription_form.php');
require_once('../vpl.class.php');
$id = required_param('id',PARAM_INT);
$vpl = new mod_vpl($id);
$vpl->require_capability(VPL_MANAGE_CAPABILITY);
$mform = new mod_vpl_fulldescription_form('fulldescription.php');
if ($mform->is_cancelled()){
	redirect(vpl_mod_ref('view.php','id',$id));
} else if ($fromform=$mform->get_data()){
	if($fromform->fulldescription){
		$vpl->add_to_log('save full description',vpl_rel_url('fulldescription.php','id',$id));
		$vpl->set_fulldescription($fromform->fulldescription);
		notice(get_string('saved',VPL));
	}
	else{
		error(get_string('notsaved',VPL));
	}
	redirect(vpl_mod_ref('view.php','id',$id));
} else {
	// this branch is executed if the form is submitted but the data doesn't validate and the form should be redisplayed
	// or on the first display of the form.

	//Display page
	$course = $vpl->get_course();
	$vpl->print_header(get_string('fulldescription',VPL));
	$vpl->print_heading_with_help('fulldescription');
	$vpl->print_configure_tabs(basename(__FILE__));
	$data = new object;
	$data->id = $id;
	$data->fulldescription = $vpl->get_fulldescription();
	$mform->set_data($data);
	$mform->display();
	$vpl->add_to_log('edit full description',vpl_rel_url('fulldescription.php','id',$id));
	$vpl->print_footer();
}

?>