<?php
/**
 * @version		$Id: grade_form.php,v 1.16 2009/07/27 12:59:10 juanca Exp $
 * @package		vpl. grade form definition
 * @copyright	Copyright (C) 2009 Juan Carlos Rodríguez-del-Pino. All rights reserved.
 * @license		GNU/GPL, see LICENSE.txt or http://www.gnu.org/licenses/gpl-2.0.html
 * @author		Juan Carlos Rodriguez-del-Pino
 **/

require_once('../../../config.php');
require_once($CFG->libdir.'/formslib.php');
require_once($CFG->libdir.'/gradelib.php');
require_once('../lib.php');
require_once('form.class.php');

class mod_vpl_grade_form extends vpl_form {
	protected $vpl;
	protected function get_scale_selection(){
		$vplinstance = $this->vpl->get_instance();
		$scaleid = $vplinstance->grade;
		$options = array();
		$options[-1]= get_string('nograde');
		if ($scaleid > 0) {
			for($i = 0 ; $i <= $scaleid; $i++){
				$options[$i] = $i.' / '.$scaleid;
			}
		} elseif($scaleid < 0) {
			$scaleid = -$scaleid;
			if ($scale = get_record('scale', 'id', $scaleid)) {
				$options = $options + make_menu_from_list($scale->scale);
			}
		}
		return $options;
	}
	
	function __construct($page,& $vpl){
		$this->vpl = & $vpl;
		parent::__construct($page);
	}
	function definition(){
		global $CFG;
		$this->addHidden('id');
		$this->addHidden('userid');
		$this->addHidden('submissionid');
		$userid = optional_param('userid',null,PARAM_INT);
		//TODO Improve grade form (recalculate grade)
		//Show assesment criteria
		//Show others evaluation
		//Type value => introduce value
		//TODO locked grading
		if($this->vpl->get_instance()->grade !=0){
			$this->addHTML(s(get_string('grade').' '));
			if($this->vpl->get_instance()->grade>0){
				$this->addText('grade','',6);
			}
			else{
				$this->addSelect('grade',$this->get_scale_selection());
			}
			$this->addHTML(' &nbsp;');
		}
		$this->addSubmitButton('save',get_string('grade'));
		$this->addCancelButton(get_string('cancel'));
		if($this->vpl->get_instance()->evaluate){
			$this->addSubmitButton('evaluate',get_string('evaluate',VPL));
		}
		$this->addSubmitButton('removegrade',get_string('removegrade',VPL));
		$this->addHTML('<br />');
		if($this->vpl->get_instance()->grade !=0){
			$this->addHTML(s(get_string('comments',VPL)).'<br />');
			$this->addTextArea('comments','',8,70);
			$this->addHTML('<br />');
		}
		if(!empty($CFG->enableoutcomes)){
			$grading_info = grade_get_grades($this->vpl->get_course()->id, 'mod', 'vpl',
					$this->vpl->get_instance()->id, $userid);
			if (!empty($grading_info->outcomes)) {
				$this->addHTML('<table border="0">');
			 	foreach($grading_info->outcomes as $oid=>$outcome) {
			 		//TODO outcomes locked
			 		//if ($outcome->grades[$userid]->locked) {
			 		//	continue;
			 		//}
				    $this->addHTML('<tr><td align="right">');
			 		$options = make_grades_menu(-$outcome->scaleid);
			 		$options[0] = get_string('nooutcome', 'grades');
					$this->addHTML(s($outcome->name));
					$this->addHTML('</td><td>');
					$this->addSelect('outcome_grade_'.$oid,$options,$outcome->grades[$userid]->grade);
				    $this->addHTML('</td></tr>');
			 	}
			 	$this->addHTML('</table>');
			 }
		}
	}
	function display(){
		print_box_start();
		parent::display();
		print_box_end();
	}
}

?>
