<?php
/**
 * @version		$Id: gradesubmission.php,v 1.6 2009/08/08 11:51:49 juanca Exp $
 * @package		vpl. grade submission
 * @copyright	Copyright (C) 2009 Juan Carlos Rodríguez-del-Pino. All rights reserved.
 * @license		GNU/GPL, see LICENSE.txt or http://www.gnu.org/licenses/gpl-2.0.html
 * @author		Juan Carlos Rodriguez-del-Pino
 **/

require_once('../../../config.php');
global $CFG, $USER;
require_once('../lib.php');
require_once('grade_form.php');
require_once('../vpl.class.php');
require_once('../vpl_submission.class.php');

$id = required_param('id',PARAM_INT);
$vpl = new mod_vpl($id);
$course = $vpl->get_course();
$instance = $vpl->get_instance();
$userid = required_param('userid',PARAM_INT);
$inpopup = optional_param('inpopup',0,PARAM_INT);
$vpl->require_capability(VPL_GRADE_CAPABILITY);
//Read records
$submissionid =  optional_param('submissionid',FALSE,PARAM_INT);
if($submissionid){
	$subinstance = get_record('vpl_submissions','id',$submissionid);
}else{
	$subinstance = $vpl->last_user_submission($userid);
}
//Print header
$CFG->stylesheets[] = vpl_mod_href('views/sh.css');
if($inpopup){
	$vpl->print_header_simple('onload="resizeSView();"');
}else{
	$vpl->print_header(get_string('grade'),false,'onload="resizeSView();"');
	$vpl->print_view_tabs(basename(__FILE__));
}

//Check consistence
if(!$subinstance){
	notice(get_string('nosubmission',VPL),vpl_mod_href('view.php','id',$id,'userid',$userid));
}
$submissionid = $subinstance->id;

if($subinstance->userid != $userid){
	print_error('vpl submission user inconsistence');
}
if($vpl->get_instance()->id != $subinstance->vpl){
	print_error('vpl submission vpl inconsistence');
}
$submission = new mod_vpl_submission($vpl,$subinstance);

$link = vpl_mod_href('forms/gradesubmission.php','id',$id,'userid',$userid);
$linkrel = vpl_rel_url('forms/gradesubmission.php','id',$id,'userid',$userid);

//no marked or marked by current user
if($subinstance->dategraded== 0 || $subinstance->grader == $USER->id){
	if($inpopup){
		$href=vpl_rel_url('gradesubmission.php','inpopup',1);
	}else{
		$href='gradesubmission.php';
	}
	$grade_form = new mod_vpl_grade_form($href,$vpl);
	if ($grade_form->is_cancelled()){ //Grading canceled
		redirect($link);
	} else if ($fromform=$grade_form->get_data()){ //Grade (new or update)
		if(isset($fromform->evaluate)){
			//TODO evaluate any submission
			redirect(vpl_mod_href('forms/evaluation.php','id',$id,'userid',$userid),'',0);
		}
		if(isset($fromform->removegrade)){
			$submission->remove_grade();
			$vpl->add_to_log('remove grade',$linkrel);
			redirect($link,5);
		}
		if($submission->is_graded()){
			$action = 'update grade';
		}else{
			$action = 'grade';
		}
		//Remove slashes added by form
		$fromform = stripslashes_safe($fromform);
		//Build log info
		$log_info='grade: '.$fromform->grade;
		foreach($fromform as $key => $value){
			if(strpos($key,'outcome_grade')===0){
				$on= substr($key,strlen('outcome_grade_'));
				$log_info .= ' o'.$on.' '.$value;
			}
		}
		$vpl->add_to_log($action,$linkrel,$log_info);
		$submission->set_grade($fromform);
		if($inpopup){
			close_window();
		}else{
			redirect($link,2);
		}
	} else {
		//Show grade form
		$vpl->add_to_log('view grade',$linkrel,'grade: '.$subinstance->grade);
		$data = new Object;
		$data->id = $vpl->get_course_module()->id;
		$data->userid = $subinstance->userid;
		$data->submissionid = $submissionid;
		if($submission->is_graded()){
			//format number removing trailing zeros
			$data->grade = rtrim(rtrim($subinstance->grade,'0'),'.,');
			$data->comments = $submission->get_grade_comments();
		}else{
			$res=$submission->getCE();
			if($res['executed']){
				$data->grade = $submission->proposedGrade($res['execution']);
				$data->comments = $submission->proposedComment($res['execution']);;
			}
		}
		if(!empty($CFG->enableoutcomes)){
			$grading_info = grade_get_grades($vpl->get_course()->id, 'mod', 'vpl',
					$vpl->get_instance()->id, $userid);
			if (!empty($grading_info->outcomes)) {
			 	foreach($grading_info->outcomes as $oid=>$outcome) {
			 		$field='outcome_grade_'.$oid;
			 		$data->$field=$outcome->grades[$userid]->grade;
			 	}
			 }
		}
		
		$grade_form->set_data($data);
		echo '<div style="height:210px; overflow:auto;">';
		echo '<div style="float:left;">';
		$grade_form->display();
		echo '</div>';
		$comments=$vpl->get_grading_help();
		if($comments>''){
			echo '<div style="float:left;width:40%;">';
			print_box_start();
			echo '<b>'.get_string('listofcomments',VPL).'</b><hr />';
			echo $comments;
			print_box_end();
		}
		echo '</div>';
		echo '</div>';
		echo '<hr />';
		echo '<div id="submission_view" style="height:400px; overflow:auto;" >';
		$submission->print_submission();
		echo '</div>';
	}
}else{
	echo '<h1>Ya evaluada o no evaluable</h1>';
}
echo vpl_include_jsfile('grade.js');
$vpl->print_footer_simple();

?>