/**
 * @version		$Id: editor.js,v 1.21 2009/07/27 12:59:10 juanca Exp $
 * @package		vpl. jscript functions to manage applet editor
 * @copyright	Copyright (C) 2009 Juan Carlos Rodríguez-del-Pino. All rights reserved.
 * @license		GNU/GPL, see LICENSE.txt or http://www.gnu.org/licenses/gpl-2.0.html
 * @author		Juan Carlos Rodriguez-del-Pino
 **/
 
//For internationalization need the vars changesNotSaved, fileNotChanged, filesNotChanged
//TODO and vpl to avery var and function name
var vpl_fileNames= new Array();
var vpl_fileDatas= new Array();

/**
 * When editing one file, this function get the initial filename
 * and data from the editor
*/
function initFile(){
  var ae = window.document.getElementById('appleteditorid');
  if(ae != null){
	  if(typeof ae.getFileName == 'function'){
		  vpl_fileNames[0]=new String(ae.getFileName(0));
		  vpl_fileDatas[0]=new String(ae.getFileContent(0));
	  }
	  else{
		  setTimeout('initFile()',250);
	  }
  } else setTimeout('initFile()',100);
}

/**
 * When editing some files, this function get the initial filenames
 * and datas from the editor
*/
function initFiles(max){
	  var ae = window.document.getElementById('appleteditorid');
  if(ae != null){
	  if(typeof ae.getFileName == 'function'){
		  for(i=0; i<max; i++){
			  vpl_fileNames[i]=new String(ae.getFileName(i));
			  vpl_fileDatas[i]=new String(ae.getFileContent(i));
		  }
	  }
	  else{
		  setTimeout('initFiles('+max+')',250);
	  }
  } else setTimeout('initFiles('+max+')',100);
}

/**
 * When editing one file, this function check data change
 * and set data in form fields
 */
function readFile(){
  var fm = window.document.getElementsByName('filedata');
  var ae = window.document.getElementById('appleteditorid');
  newData = new String(ae.getFileContent(0));
  previousData = new String(vpl_fileDatas[0]);
  if(previousData.localeCompare(newData)==0){
     alert(fileNotChanged);
     return false;
  }else{
     fm.filedata.value = newData;
     fm.fontsize.value = ae.getFontSize();
     vpl_fileDatas[0]=newData;
  }
  return true;
}

/**
* This function set edition target in form (XHTML restriction)
*/
function setETarget(){
  var fm = window.document.getElementById('mform1');
  fm.target='edition_result';
  var er= window.document.getElementById('div_er');
  er.innerHTML='<iframe name="edition_result"></iframe>';	
}

/**
* When editing files, this function check if data change
* and set data in form fields
*/
function readFiles(){
  if(!filesChanged()){
     alert(filesNotChanged);
     return false;
  }
  var fm = window.document.getElementById('mform1');
  var ae = window.document.getElementById('appleteditorid');
  for(i=0; i<100; i++){
     if(fm.elements['filename'+i]==null) break;
     newName = new String(ae.getFileName(i));
     fm.elements['filename'+i].value=newName;
     vpl_fileNames[i]=newName;
     newData = new String(ae.getFileContent(i));
     fm.elements['filedata'+i].value=newData;
     vpl_fileDatas[i]=newData;
  }
  fm.fontsize.value = ae.getFontSize();
  return true;
}

/**
* This function check if datas have changed
*/
function filesChanged(){
  var fm = window.document.getElementById('mform1');
  var ae = window.document.getElementById('appleteditorid');
  if(ae == null){
     return false;
  }
  if(fm.Fichero){
        newData = new String(ae.getFileContent(0));
        if(newData.localeCompare(vpl_fileDatas[0])!=0)
           return true;
  }else{
     for(i=0; i<100; i++){
        newName = new String(ae.getFileName(i));
        if(fm.elements['filename'+i]==null &&
           newName.localeCompare('')==0)
           return false;
        previousName = vpl_fileNames[i];
        newData = new String(ae.getFileContent(i));
        previousData = vpl_fileDatas[i];
        if(newName.localeCompare(previousName)!=0 ||
            previousData.localeCompare(newData)!=0){
           return true;
        }
     }
  }
  return false;
}

/**
* This function alert if files in editor have change
*/
function alertFilesChanged(){
  if(filesChanged()){
     alert(filesChangedNotSaved);
  }
  return true;
}

/**
* This function install the checker to alert if going to leave the page
* and files have changed 
*/
function installCloseCheck(){
   window.onbeforeunload= function(){
      if(filesChanged()){
         return changesNotSaved;
      }
   }
}

/**
* This function resize the applet to greatest visible size 
*/
var appletWidth=0;
var appletHeight=0;
function resizeApplet(){
	var offset=3;
	var page= window.document.getElementById('page');
	var applet=window.document.getElementById('appleteditorid');
    appletRec = applet.getBoundingClientRect();
    pageRec = page.getBoundingClientRect();
    var diffHeight=(pageRec.bottom-pageRec.top)-(appletRec.bottom-appletRec.top);
    var newWidth=document.documentElement.clientWidth-2*appletRec.left;
    var newHeight=document.documentElement.clientHeight-diffHeight-offset;
    if(appletWidth!= newWidth || appletHeight != newHeight){
        if(appletWidth< newWidth) newWidth -= offset;
        if(appletHeight< newHeight) newHeight -= offset;
        applet.width = newWidth;
        applet.height  = newHeight;
        if(typeof applet.setSize == 'function'){
	    	appletWidth= newWidth;
		    appletHeight= newHeight;
		    applet.setSize(newWidth,newHeight);
        }
    }
}
/**
* This set the resize controler
*/
window.onresize=resizeApplet;

