<?php
/**
 * @version		$Id: similarity_cpp.class.php,v 1.3 2009/07/27 12:59:10 juanca Exp $
 * @package		vpl. C++ language similarity clases
 * @copyright	Copyright (C) 2009 Juan Carlos Rodríguez-del-Pino. All rights reserved.
 * @license		GNU/GPL, see LICENSE.txt or http://www.gnu.org/licenses/gpl-2.0.html
 * @author		Juan Carlos Rodriguez-del-Pino
 **/

require_once('similarity_c.class.php');

class vpl_similarity_cpp extends vpl_similarity_c{
	public function get_type(){
		return 2;
	}
	public function sintax_normalize(&$tokens){
		$ret = array();
		$prev = new vpl_token(vpl_token_type::identifier,'',0);
		foreach($tokens as $token){
			if($token->type == vpl_token_type::operator){
				//++ and -- operator
				//:: operator
				//(*p). and p->
				//+=, -=, *=, etc
				switch($token->value){
					case '++':
						$token->value='=';
						$ret[]=$token;
						$token->value='+';
						$ret[]=$token;
						break;
					case '--':
						$token->value='=';
						$ret[]=$token;
						$token->value='-';
						$ret[]=$token;
						break;
					case '+=':
						$token->value='=';
						$ret[]=$token;
						$token->value='+';
						$ret[]=$token;
						break;
					case '-=':
						$token->value='=';
						$ret[]=$token;
						$token->value='-';
						$ret[]=$token;
						break;
					case '*=':
						$token->value='=';
						$ret[]=$token;
						$token->value='*';
						$ret[]=$token;
						break;
					case '/=':
						$token->value='=';
						$ret[]=$token;
						$token->value='/';
						$ret[]=$token;
						break;
					case '%=':
						$token->value='=';
						$ret[]=$token;
						$token->value='%';
						$ret[]=$token;
						break;
					case '->':
						if($prev->value == 'this'){
							break;
						}
						$token->value='(';
						$ret[]=$token;
						$token->value='*';
						$ret[]=$token;
						$token->value=')';
						$ret[]=$token;
						$token->value='.';
						$ret[]=$token;
						break;
					case '::':
						break;
					default:
						$ret[]=$token;
				}
				$prev=$token;
			}
			//TODO remove {;}
			//TODO remove (p)
		}
		return $ret;
	}
	public function get_tokenizer(){
		return vpl_tokenizer_factory::get('cpp');
	}
}

?>