<?php
/**
 * @version		$Id: sh_base.class.php,v 1.10 2009/07/27 12:59:10 juanca Exp $
 * @package		vpl. vpl Syntaxhighlighters base class
 * @copyright	Copyright (C) 2009 Juan Carlos Rodríguez-del-Pino. All rights reserved.
 * @license		GNU/GPL, see LICENSE.txt or http://www.gnu.org/licenses/gpl-2.0.html
 * @author		Juan Carlos Rodriguez-del-Pino
 **/

require_once('../../../config.php');
class vpl_sh_base{
	const CR ="\r";
	const LF ="\n";
	const TAB ="\t";
	protected $reserved;
	protected $line_number;
	protected $file_name;
	protected $action_line;
	const c_variable = 'vpl_v';
	const c_string = 'vpl_s';
	const c_comment = 'vpl_c';
	const c_macro = 'vpl_m';
	const c_reserved = 'vpl_r';
	const c_general = 'vpl_g';
	const endTag= '</span>';
	static protected $CSS_printed=false;
	protected function print_CSS(){
		if(!self::$CSS_printed){
			echo "<style>\n";
			echo '.'.self::c_variable.' {font-style: italic;}'."\n";
			echo '.'.self::c_string.' {color:blue}'."\n";
			echo '.'.self::c_comment.' {color:#92C991}'."\n";
			echo '.'.self::c_macro.' {color:#000080}'."\n";
			echo '.'.self::c_reserved.' {color:#923B3B; font-weight : bold;}'."\n";
			echo '.'.self::c_general.' {font-size: 14px;}'."\n";
			echo "</style>\n";
			self::$CSS_printed=true;
		}
	}
	protected function show_line_number(){
		$name = $this->file_name.'.'.$this->line_number;
		echo '<a name="',$name.'"></a>';
		$text = sprintf('%5d',$this->line_number);
		if($this->action_line) {
			echo '<a href="javascript:actionLine(\''.$name.'\')")>'.$text.'</a>';
		}
		else {
			echo $text;
		}
		echo ' ';
		$this->line_number++;
	}

	protected function show_text($text){
		//Same text may be not UTF-8
		echo @htmlspecialchars($text,ENT_QUOTES,'UTF-8');
	}

	protected function show_pending(&$rest){
		$this->show_text($rest);
		$rest='';
	}

	protected function initTag($class){
		echo '<span class="'.$class.'">';
	}
	protected function endTag(){
		echo '</span>';
	}

	protected function begin($filename){
		$this->file_name = $filename;
		echo '<h3>'.$filename.'</h3>';
		$this->line_number=1;
		print_box_start();
		echo '<pre class="'.self::c_general.'">';
	}
	protected function end(){
		echo '</pre>';
		print_box_end();
	}
	public function __construct(){

	}
	function print_file($filename, $filedata){
		$this->begin($filename);
		$pending='';
		$l = strlen($filedata);
		if($l){
			$this->show_line_number();
		}
		for($i=0;$i<$l;$i++){
			$current=$filedata[$i];
			if($i < ($l-1)) {
				$next = $filedata[$i+1];
			}else{
				$next ='';
			}
			if($current == self::CR){
				if($next == self::LF) {
					continue;
				}else{
					$current = self::LF;
				}
			}
			$pending .= $current;
			if($current == self::LF){
				$this->show_pending($pending);
				$this->show_line_number();
			}
		}
		$this->show_pending($pending);
		$this->end();
	}
}

?>